import pycurl
import sys, getopt, os
from StringIO import StringIO
import json
import copy
import time
from importNormativeTypes import importNormativeTypes
from importHeatTypes import importHeatTypes
from importCommon import *
import importCommon

def usage():
	print sys.argv[0], '[-i <be host> | --ip=<be host>] [-p <be port> | --port=<be port> ] [-u <user userId> | --user=<user userId> ] [-d <true|false> | --debug=<true|false>] [-v <true|false> | --updateversion=<true|false>]'

def handleResults(results, updateversion):
	printFrameLine()
	for result in results:
		printNameAndReturnCode(result[0], result[1])
	printFrameLine()
	
	responseCodes = [200, 201]
	
	if(updateversion == 'false'):
		responseCodes = [200, 201, 409]
	
	failedResults = filter(lambda x: x[1] == None or x[1] not in responseCodes, results)
	if (len(failedResults) > 0):
		errorAndExit(1, None)

def main(argv):
	print 'Number of arguments:', len(sys.argv), 'arguments.'

	beHost = 'localhost' 
	bePort = '8080'
	adminUser = 'jh0003'
	debugf = None
	updateversion = 'true'
	importCommon.debugFlag = False 

	try:
		opts, args = getopt.getopt(argv,"i:p:u:d:v:h",["ip=","port=","user=","debug=","updateversion="])
	except getopt.GetoptError:
		usage()
		errorAndExit(2, 'Invalid input')
	
	for opt, arg in opts:
	#print opt, arg
		if opt == '-h':
			usage()                        
			sys.exit(3)
		elif opt in ("-i", "--ip"):
			beHost = arg
		elif opt in ("-p", "--port"):
			bePort = arg
		elif opt in ("-u", "--user"):
			adminUser = arg
		elif opt in ("-d", "--debug"):
			print arg
			debugf = bool(arg.lower() == "true" or arg.lower() == "yes")
		elif opt in ("-v", "--updateversion"):
			print arg
			if (arg.lower() == "false" or arg.lower() == "no"):
				updateversion = 'false'			

	print 'be host =',beHost,', be port =', bePort,', user =', adminUser, ', debug =', debugf, ', updateversion =', updateversion

	if (debugf != None):
		print 'set debug mode to ' + str(debugf)
		importCommon.debugFlag = debugf
	
	if ( beHost == None ):
		usage()
		sys.exit(3)

	print sys.argv[0]
	pathdir = os.path.dirname(os.path.realpath(sys.argv[0]))      
	debug("path dir =" + pathdir)

	baseFileLocation = pathdir + "/../../../import/tosca/"
	
	fileLocation = baseFileLocation + "normative-types/"
	results = importNormativeTypes(beHost, bePort, adminUser, fileLocation, updateversion)
	handleResults(results, updateversion)

	fileLocation = baseFileLocation + "heat-types/"
	resultsHeat = importHeatTypes(beHost, bePort, adminUser, fileLocation, updateversion)
	handleResults(resultsHeat, updateversion)

	errorAndExit(0, None)	

if __name__ == "__main__":
        main(sys.argv[1:])

